#
#
#

divert(-1)
changequote(`[',`]')

## Parameter macros to M4:
# M4_prefix_dir (/usr)		override: make prefix=
# M4_sysconfdir (/etc)		override: make syscondfir=
# M4_shinonome_srcdir (shinonome-plus-0.9.12-src)
# M4_font_misc_srcdir (font-misc-misc-1.1.2)
# without_shinonome_plus (undef)

## prefix dir
ifdef([M4_prefix_dir],,
[define([M4_prefix_dir],/usr)]
)
ifdef([M4_sysconfdir],,
[define([M4_sysconfdir],/etc)]
)
## directory names; change these on upstream update
ifdef([M4_shinonome_srcdir],,
[define([M4_shinonome_srcdir],[shinonome-plus-0.9.12-src])]
)
ifdef([M4_font_misc_srcdir],,
[define([M4_font_misc_srcdir],[font-misc-misc-1.1.2])]
)

ifdef([without_shinonome_plus],,define([with_shinonome_plus],1))


## 
define(D_SHNMFONTS_U,1)
define(D_SHNMFONTS_U_PCFGZ,2)
define(D_SHNMFONTS_UB_PCFGZ,3)
define(D_PLAIN,9)

define([BUILD_BDF],[$1.bdf: $2
	perl ./merge16.pl \
	$2 \
	> [$]@ dnl
divert(D_SHNMFONTS_U)	$1.bdf \
divert(D_PLAIN)])

define([BUILD_PCFGZ],[$1.pcf.gz: $1.bdf
	bdftopcf $1.bdf | gzip -9 > [$]@ dnl
divert(D_SHNMFONTS_U_PCFGZ)	$1.pcf.gz \
divert(D_PLAIN)])

define([BUILD_BOLD_PCFGZ],[$1b.pcf.gz: $1.bdf
	ifelse($2,,$(MKBOLD_R),$2) $1.bdf | bdftopcf | gzip -9 > [$]@ dnl
divert(D_SHNMFONTS_UB_PCFGZ)	$1b.pcf.gz \
divert(D_PLAIN)])

##
divert(D_SHNMFONTS_U)dnl
SHNMFONTS_U= \
divert(D_SHNMFONTS_U_PCFGZ)dnl
SHNMFONTS_U_PCFGZ= \
divert(D_SHNMFONTS_UB_PCFGZ)dnl
SHNMFONTS_UB_PCFGZ= \
divert(D_PLAIN)dnl

# overridden by "make install datadir=..."
prefix=M4_prefix_dir
datadir=$(prefix)/share
sysconfdir=M4_sysconfdir

# install target /usr/share/X11/fonts/shinonome/
usr_share_x11_fonts_shinonome=$(datadir)/X11/fonts/shinonome
fontpath_d=$(sysconfdir)/X11/fontpath.d


all: $(SHNMFONTS_U_PCFGZ) $(SHNMFONTS_UB_PCFGZ)

clean::
	rm -f $(SHNMFONTS_U)
	rm -f add.d/*.bdf
	rm -f *.pcf.gz


## directory names; change these on upstream update
SHINONOME_SRC=M4_shinonome_srcdir
MISC_SRC=M4_font_misc_srcdir

#single file hook to fire shinonome build
$(SHINONOME_SRC)/12/latin1/shnm6x12a.bdf shinonome: 
	cd $(SHINONOME_SRC); ./configure --with-fontdir=$(usr_share_x11_fonts_shinonome) --disable-bold --disable-italic --disable-bolditalic
	cd $(SHINONOME_SRC); $(MAKE) bdf

veryclean:: clean
	cd $(SHINONOME_SRC); $(MAKE) clean
distclean:: clean
	cd $(SHINONOME_SRC); $(MAKE) $@

BIT2BDF=$(SHINONOME_SRC)/tools/bit2bdf
MKBOLD_R=$(SHINONOME_SRC)/tools/mkbold -r
MKBOLD_L=$(SHINONOME_SRC)/tools/mkbold -l

#BuildRequires: perl perl(Encode)
#BuildRequires: /usr/bin/bdftopcf
#Requires: /usr/bin/mkfontdir

######

# 6x12: fill from misc 6x12
add.d/add12n.bdf: add.d/add12n.bit
	$(BIT2BDF) add.d/add12n.bit > $@

BUILD_BDF([shnm6x12u],
$(SHINONOME_SRC)/12/latin1/shnm6x12a.bdf $(SHINONOME_SRC)/12/hankaku/shnm6x12r.bdf add.d/add12n.bdf $(MISC_SRC)/6x12.bdf )
BUILD_PCFGZ(shnm6x12u)
BUILD_BOLD_PCFGZ(shnm6x12u,$(MKBOLD_R))

ifelse(with_shinonome_plus,,,[# shinonome-plus serif1,marumoji1
BUILD_BDF(shnm6x12su,
$(SHINONOME_SRC)/12/serif1/shnm6x12s.bdf $(SHINONOME_SRC)/12/hankaku/shnm6x12r.bdf add.d/add12n.bdf $(MISC_SRC)/6x12.bdf )
BUILD_PCFGZ(shnm6x12su)
BUILD_BOLD_PCFGZ(shnm6x12su, $(MKBOLD_R))

BUILD_BDF(shnm6x12maruu,
$(SHINONOME_SRC)/12/marumoji1/shnm6x12maru.bdf $(SHINONOME_SRC)/12/hankaku/shnm6x12r.bdf  add.d/add12n.bdf $(MISC_SRC)/6x12.bdf )
BUILD_PCFGZ(shnm6x12maruu)
BUILD_BOLD_PCFGZ(shnm6x12maruu, $(MKBOLD_R))
])

# 12x12 has kanjic,marumoji,mincho variants
BUILD_BDF(shnmk12u,
$(SHINONOME_SRC)/12/kanjic/shnmk12.bdf )
BUILD_BDF(shnmk12maruu,
$(SHINONOME_SRC)/12/marumoji/shnmk12maru.bdf )
BUILD_BDF(shnmk12minu,
$(SHINONOME_SRC)/12/mincho/shnmk12min.bdf )

BUILD_PCFGZ(shnmk12u)
BUILD_PCFGZ(shnmk12maruu)
BUILD_PCFGZ(shnmk12minu)
BUILD_BOLD_PCFGZ(shnmk12u, $(MKBOLD_R))
BUILD_BOLD_PCFGZ(shnmk12maruu, $(MKBOLD_R))
BUILD_BOLD_PCFGZ(shnmk12minu, $(MKBOLD_R))

# 7x14, merge with misc
# missing glyphs in misc, added by add14n.bit: 
# 0x203b,0x212b,0x2234,0x2235,0x223d,0x2252,0x2266,0x2267,0x2312,
# 0x25c7,0x25ce,0x25ef,0x2605,0x2606,0x266f
add.d/add14n.bdf: add.d/add14n.bit
	 $(BIT2BDF) add.d/add14n.bit > $@

BUILD_BDF(shnm7x14u,
$(SHINONOME_SRC)/14/latin1/shnm7x14a.bdf $(SHINONOME_SRC)/14/hankaku/shnm7x14r.bdf add.d/add14n.bdf $(MISC_SRC)/7x14.bdf )
BUILD_PCFGZ(shnm7x14u)
BUILD_BOLD_PCFGZ(shnm7x14u,$(MKBOLD_R))

# 14x14 comes in gothic and mincho
BUILD_BDF(shnmk14u,
$(SHINONOME_SRC)/14/kanjic/shnmk14.bdf )
BUILD_BDF(shnmk14minu,
$(SHINONOME_SRC)/14/mincho/shnmk14min.bdf )
BUILD_PCFGZ(shnmk14u)
BUILD_PCFGZ(shnmk14minu)

BUILD_BOLD_PCFGZ(shnmk14u,$(MKBOLD_L))
BUILD_BOLD_PCFGZ(shnmk14minu,$(MKBOLD_L))

ifelse(with_shinonome_plus,,,[# shinonome-plus 7x14s
BUILD_BDF(shnm7x14s,
$(SHINONOME_SRC)/14/serif1/shnm7x14s.bdf $(SHINONOME_SRC)/14/hankaku/shnm7x14r.bdf add.d/add14n.bdf $(MISC_SRC)/7x14.bdf )
BUILD_PCFGZ(shnm7x14s)
BUILD_BOLD_PCFGZ(shnm7x14s, $(MKBOLD_R))
])

# 8x16: fill additional glyphs, derived from 9x18
add.d/add16n.bdf: add.d/add16n.bit
	 $(BIT2BDF) add.d/add16n.bit > $@

BUILD_BDF(shnm8x16u,
$(SHINONOME_SRC)/16/latin1/shnm8x16a.bdf $(SHINONOME_SRC)/16/hankaku/shnm8x16r.bdf add.d/add16n.bdf )
BUILD_PCFGZ(shnm8x16u)

# 16x16 in gothic and mincho
BUILD_BDF(shnmk16u, $(SHINONOME_SRC)/16/kanjic/shnmk16.bdf )
BUILD_BDF(shnmk16minu, $(SHINONOME_SRC)/16/mincho/shnmk16min.bdf )
BUILD_PCFGZ(shnmk16u)
BUILD_PCFGZ(shnmk16minu)

BUILD_BOLD_PCFGZ(shnm8x16u, $(MKBOLD_R))
BUILD_BOLD_PCFGZ(shnmk16u, $(MKBOLD_L))
BUILD_BOLD_PCFGZ(shnmk16minu, $(MKBOLD_L))

ifelse(with_shinonome_plus,,,[# shinonome-plus 8x16 serif1
BUILD_BDF(shnm8x16s,
$(SHINONOME_SRC)/16/serif1/shnm8x16s.bdf $(SHINONOME_SRC)/16/hankaku/shnm8x16r.bdf add.d/add16n.bdf )
BUILD_PCFGZ(shnm8x16s)
BUILD_BOLD_PCFGZ(shnm8x16s, $(MKBOLD_R))
])

## shinonome 9x18 limited to latin1 and hankaku-kana; fill from misc 9x18
BUILD_BDF(shnm9x18u,
$(SHINONOME_SRC)/18/latin1/shnm9x18a.bdf $(SHINONOME_SRC)/18/hankaku/shnm9x18r.bdf $(MISC_SRC)/9x18.bdf )
BUILD_PCFGZ(shnm9x18u)
## does not install 9x18 bold, as there's no corresponding wide font;
## drop the narrow bold font to let xterm overstike
# BUILD_BOLD_PCFGZ(shnm9x18u, $(MKBOLD_R))
## shinonome doesn't have 18x18 kanji; use 18x18ja.bdf (jiskan16+padding)


##
install: $(SHNMFONTS_U_PCFGZ) $(SHNMFONTS_UB_PCFGZ) fonts.alias
	mkdir -p $(DESTDIR)$(usr_share_x11_fonts_shinonome)
	for pcf_gz in $(SHNMFONTS_U_PCFGZ) $(SHNMFONTS_UB_PCFGZ) fonts.alias; do \
		install -c -p -m 644 $$pcf_gz $(DESTDIR)$(usr_share_x11_fonts_shinonome)/; \
	done
	mkfontdir $(DESTDIR)$(usr_share_x11_fonts_shinonome)
	#fc-cache $(DESTDIR)$(usr_share_x11_fonts_shinonome)

	#mkdir -p $(DESTDIR)$(fontpath_d)
	#ln -s $(usr_share_x11_fonts_shinonome) $(DESTDIR)$(fontpath_d)/shinonome
	#service xfs reload || : #RHEL7 doesn't use xfs

	if [[ -n "$$DISPLAY" ]]; then xset fp rehash; fi

Makefile: Makefile.m4
	m4 Makefile.m4 > $@

source: README.plus Makefile Makefile.m4 merge16.pl add.d fonts.alias
	tar zcvf shinonome-unicode-build.tar.gz \
	README.plus Makefile Makefile.m4 merge16.pl add.d/*.bit fonts.alias
#clean::
#	rm -f shinonome-unicode-build.tar.gz


dnl ## undivert all output
divert(0)
undivert(D_SHNMFONTS_U)

undivert(D_SHNMFONTS_U_PCFGZ)

undivert(D_SHNMFONTS_UB_PCFGZ)

undivert(D_PLAIN)
